#include <iostream>
#include <vector>
using namespace std;
int main(int argc, char** argv) {
	ios_base::sync_with_stdio(false);
	
	int n;
	cin >>n;
	for(int i=0;i<n-1;i++)
	{
		int l,r;
		cin >>l>>r;
	}
	
	vector<int> v(n);
	for(int i=0;i<n;i++)
	{
		cin >>v[i];
		
	}
	
	int q;
	cin >>q;
	if(q==0)
	{
		int l,r;
		if(n^1)
		{
			l=n/2-1;
			r=n/2;
		}
		else
		{
			l=n/2;
			r=n/2;
		}
		
		int mx=0,poz=0;
		
		while(l>-1 || r<n)
		{
			if(l>-1 && r<n)
			{
				if(mx<v[r])
				{
					mx=v[r];
					poz=r;
				}
				if(mx<v[l])
				{
					mx=v[l];
					poz=l;
				}
				
				l--;
				r++;
			}
			else
			{
				if(l>-1)
				{
					if(mx<v[l])
					{
						mx=v[l];
						poz=l;
					}
					l--;
				}
				else
				{
					if(mx<v[r])
					{
						mx=v[r];
						poz=r;
					}
					r++;
				}
			}
		}
		cout <<poz+1<<"\n";
	}
	else
	{
		cout <<"kraj\n";
	}
	
	return 0;
}